-- Do not manually edit this file, it was auto-generated by dillonkearns/elm-graphql
-- https://github.com/dillonkearns/elm-graphql
module Api.Object.Person exposing (..)

import Graphql.Internal.Builder.Argument as Argument exposing (Argument)
import Graphql.Internal.Builder.Object as Object
import Graphql.SelectionSet exposing (SelectionSet)
import Graphql.OptionalArgument exposing (OptionalArgument(..))
import Graphql.Operation exposing (RootMutation, RootQuery, RootSubscription)
import Api.Object
import Api.Interface
import Api.Union
import Api.Scalar
import Api.InputObject
import Api.ScalarCodecs
import Json.Decode as Decode
import Graphql.Internal.Encode as Encode exposing (Value)

{-| The name of this person.
-}
name : SelectionSet (Maybe String) Api.Object.Person
name =
      Object.selectionForField "(Maybe String)" "name" [] (Decode.string |> Decode.nullable)


{-| The birth year of the person, using the in-universe standard of BBY or ABY -
Before the Battle of Yavin or After the Battle of Yavin. The Battle of Yavin is
a battle that occurs at the end of Star Wars episode IV: A New Hope.
-}
birthYear : SelectionSet (Maybe String) Api.Object.Person
birthYear =
      Object.selectionForField "(Maybe String)" "birthYear" [] (Decode.string |> Decode.nullable)


{-| The eye color of this person. Will be "unknown" if not known or "n/a" if the
person does not have an eye.
-}
eyeColor : SelectionSet (Maybe String) Api.Object.Person
eyeColor =
      Object.selectionForField "(Maybe String)" "eyeColor" [] (Decode.string |> Decode.nullable)


{-| The gender of this person. Either "Male", "Female" or "unknown",
"n/a" if the person does not have a gender.
-}
gender : SelectionSet (Maybe String) Api.Object.Person
gender =
      Object.selectionForField "(Maybe String)" "gender" [] (Decode.string |> Decode.nullable)


{-| The hair color of this person. Will be "unknown" if not known or "n/a" if the
person does not have hair.
-}
hairColor : SelectionSet (Maybe String) Api.Object.Person
hairColor =
      Object.selectionForField "(Maybe String)" "hairColor" [] (Decode.string |> Decode.nullable)


{-| The height of the person in centimeters.
-}
height : SelectionSet (Maybe Int) Api.Object.Person
height =
      Object.selectionForField "(Maybe Int)" "height" [] (Decode.int |> Decode.nullable)


{-| The mass of the person in kilograms.
-}
mass : SelectionSet (Maybe Float) Api.Object.Person
mass =
      Object.selectionForField "(Maybe Float)" "mass" [] (Decode.float |> Decode.nullable)


{-| The skin color of this person.
-}
skinColor : SelectionSet (Maybe String) Api.Object.Person
skinColor =
      Object.selectionForField "(Maybe String)" "skinColor" [] (Decode.string |> Decode.nullable)


{-| A planet that this person was born on or inhabits.
-}
homeworld : SelectionSet decodesTo Api.Object.Planet
 -> SelectionSet (Maybe decodesTo) Api.Object.Person
homeworld object____ =
      Object.selectionForCompositeField "homeworld" [] (object____) (Basics.identity >> Decode.nullable)


type alias FilmConnectionOptionalArguments = { after : OptionalArgument String
 , first : OptionalArgument Int
 , before : OptionalArgument String
 , last : OptionalArgument Int }

filmConnection : (FilmConnectionOptionalArguments -> FilmConnectionOptionalArguments)
 -> SelectionSet decodesTo Api.Object.PersonFilmsConnection
 -> SelectionSet (Maybe decodesTo) Api.Object.Person
filmConnection fillInOptionals____ object____ =
    let
        filledInOptionals____ =
            fillInOptionals____ { after = Absent, first = Absent, before = Absent, last = Absent }

        optionalArgs____ =
            [ Argument.optional "after" filledInOptionals____.after (Encode.string), Argument.optional "first" filledInOptionals____.first (Encode.int), Argument.optional "before" filledInOptionals____.before (Encode.string), Argument.optional "last" filledInOptionals____.last (Encode.int) ]
                |> List.filterMap Basics.identity
    in
      Object.selectionForCompositeField "filmConnection" optionalArgs____ (object____) (Basics.identity >> Decode.nullable)


{-| The species that this person belongs to, or null if unknown.
-}
species : SelectionSet decodesTo Api.Object.Species
 -> SelectionSet (Maybe decodesTo) Api.Object.Person
species object____ =
      Object.selectionForCompositeField "species" [] (object____) (Basics.identity >> Decode.nullable)


type alias StarshipConnectionOptionalArguments = { after : OptionalArgument String
 , first : OptionalArgument Int
 , before : OptionalArgument String
 , last : OptionalArgument Int }

starshipConnection : (StarshipConnectionOptionalArguments -> StarshipConnectionOptionalArguments)
 -> SelectionSet decodesTo Api.Object.PersonStarshipsConnection
 -> SelectionSet (Maybe decodesTo) Api.Object.Person
starshipConnection fillInOptionals____ object____ =
    let
        filledInOptionals____ =
            fillInOptionals____ { after = Absent, first = Absent, before = Absent, last = Absent }

        optionalArgs____ =
            [ Argument.optional "after" filledInOptionals____.after (Encode.string), Argument.optional "first" filledInOptionals____.first (Encode.int), Argument.optional "before" filledInOptionals____.before (Encode.string), Argument.optional "last" filledInOptionals____.last (Encode.int) ]
                |> List.filterMap Basics.identity
    in
      Object.selectionForCompositeField "starshipConnection" optionalArgs____ (object____) (Basics.identity >> Decode.nullable)


type alias VehicleConnectionOptionalArguments = { after : OptionalArgument String
 , first : OptionalArgument Int
 , before : OptionalArgument String
 , last : OptionalArgument Int }

vehicleConnection : (VehicleConnectionOptionalArguments -> VehicleConnectionOptionalArguments)
 -> SelectionSet decodesTo Api.Object.PersonVehiclesConnection
 -> SelectionSet (Maybe decodesTo) Api.Object.Person
vehicleConnection fillInOptionals____ object____ =
    let
        filledInOptionals____ =
            fillInOptionals____ { after = Absent, first = Absent, before = Absent, last = Absent }

        optionalArgs____ =
            [ Argument.optional "after" filledInOptionals____.after (Encode.string), Argument.optional "first" filledInOptionals____.first (Encode.int), Argument.optional "before" filledInOptionals____.before (Encode.string), Argument.optional "last" filledInOptionals____.last (Encode.int) ]
                |> List.filterMap Basics.identity
    in
      Object.selectionForCompositeField "vehicleConnection" optionalArgs____ (object____) (Basics.identity >> Decode.nullable)


{-| The ISO 8601 date format of the time that this resource was created.
-}
created : SelectionSet (Maybe String) Api.Object.Person
created =
      Object.selectionForField "(Maybe String)" "created" [] (Decode.string |> Decode.nullable)


{-| The ISO 8601 date format of the time that this resource was edited.
-}
edited : SelectionSet (Maybe String) Api.Object.Person
edited =
      Object.selectionForField "(Maybe String)" "edited" [] (Decode.string |> Decode.nullable)


{-| The ID of an object
-}
id : SelectionSet Api.ScalarCodecs.Id Api.Object.Person
id =
      Object.selectionForField "ScalarCodecs.Id" "id" [] (Api.ScalarCodecs.codecs |> Api.Scalar.unwrapCodecs |> .codecId |> .decoder)
