-- Do not manually edit this file, it was auto-generated by dillonkearns/elm-graphql
-- https://github.com/dillonkearns/elm-graphql
module Api.Object.Starship exposing (..)

import Graphql.Internal.Builder.Argument as Argument exposing (Argument)
import Graphql.Internal.Builder.Object as Object
import Graphql.SelectionSet exposing (SelectionSet)
import Graphql.OptionalArgument exposing (OptionalArgument(..))
import Graphql.Operation exposing (RootMutation, RootQuery, RootSubscription)
import Api.Object
import Api.Interface
import Api.Union
import Api.Scalar
import Api.InputObject
import Api.ScalarCodecs
import Json.Decode as Decode
import Graphql.Internal.Encode as Encode exposing (Value)

{-| The name of this starship. The common name, such as "Death Star".
-}
name : SelectionSet (Maybe String) Api.Object.Starship
name =
      Object.selectionForField "(Maybe String)" "name" [] (Decode.string |> Decode.nullable)


{-| The model or official name of this starship. Such as "T-65 X-wing" or "DS-1
Orbital Battle Station".
-}
model : SelectionSet (Maybe String) Api.Object.Starship
model =
      Object.selectionForField "(Maybe String)" "model" [] (Decode.string |> Decode.nullable)


{-| The class of this starship, such as "Starfighter" or "Deep Space Mobile
Battlestation"
-}
starshipClass : SelectionSet (Maybe String) Api.Object.Starship
starshipClass =
      Object.selectionForField "(Maybe String)" "starshipClass" [] (Decode.string |> Decode.nullable)


{-| The manufacturers of this starship.
-}
manufacturers : SelectionSet (Maybe (List (Maybe String))) Api.Object.Starship
manufacturers =
      Object.selectionForField "(Maybe (List (Maybe String)))" "manufacturers" [] (Decode.string |> Decode.nullable |> Decode.list |> Decode.nullable)


{-| The cost of this starship new, in galactic credits.
-}
costInCredits : SelectionSet (Maybe Float) Api.Object.Starship
costInCredits =
      Object.selectionForField "(Maybe Float)" "costInCredits" [] (Decode.float |> Decode.nullable)


{-| The length of this starship in meters.
-}
length : SelectionSet (Maybe Float) Api.Object.Starship
length =
      Object.selectionForField "(Maybe Float)" "length" [] (Decode.float |> Decode.nullable)


{-| The number of personnel needed to run or pilot this starship.
-}
crew : SelectionSet (Maybe String) Api.Object.Starship
crew =
      Object.selectionForField "(Maybe String)" "crew" [] (Decode.string |> Decode.nullable)


{-| The number of non-essential people this starship can transport.
-}
passengers : SelectionSet (Maybe String) Api.Object.Starship
passengers =
      Object.selectionForField "(Maybe String)" "passengers" [] (Decode.string |> Decode.nullable)


{-| The maximum speed of this starship in atmosphere. null if this starship is
incapable of atmosphering flight.
-}
maxAtmospheringSpeed : SelectionSet (Maybe Int) Api.Object.Starship
maxAtmospheringSpeed =
      Object.selectionForField "(Maybe Int)" "maxAtmospheringSpeed" [] (Decode.int |> Decode.nullable)


{-| The class of this starships hyperdrive.
-}
hyperdriveRating : SelectionSet (Maybe Float) Api.Object.Starship
hyperdriveRating =
      Object.selectionForField "(Maybe Float)" "hyperdriveRating" [] (Decode.float |> Decode.nullable)


{-| The Maximum number of Megalights this starship can travel in a standard hour.
A "Megalight" is a standard unit of distance and has never been defined before
within the Star Wars universe. This figure is only really useful for measuring
the difference in speed of starships. We can assume it is similar to AU, the
distance between our Sun (Sol) and Earth.
-}
mglt : SelectionSet (Maybe Int) Api.Object.Starship
mglt =
      Object.selectionForField "(Maybe Int)" "MGLT" [] (Decode.int |> Decode.nullable)


{-| The maximum number of kilograms that this starship can transport.
-}
cargoCapacity : SelectionSet (Maybe Float) Api.Object.Starship
cargoCapacity =
      Object.selectionForField "(Maybe Float)" "cargoCapacity" [] (Decode.float |> Decode.nullable)


{-| The maximum length of time that this starship can provide consumables for its
entire crew without having to resupply.
-}
consumables : SelectionSet (Maybe String) Api.Object.Starship
consumables =
      Object.selectionForField "(Maybe String)" "consumables" [] (Decode.string |> Decode.nullable)


type alias PilotConnectionOptionalArguments = { after : OptionalArgument String
 , first : OptionalArgument Int
 , before : OptionalArgument String
 , last : OptionalArgument Int }

pilotConnection : (PilotConnectionOptionalArguments -> PilotConnectionOptionalArguments)
 -> SelectionSet decodesTo Api.Object.StarshipPilotsConnection
 -> SelectionSet (Maybe decodesTo) Api.Object.Starship
pilotConnection fillInOptionals____ object____ =
    let
        filledInOptionals____ =
            fillInOptionals____ { after = Absent, first = Absent, before = Absent, last = Absent }

        optionalArgs____ =
            [ Argument.optional "after" filledInOptionals____.after (Encode.string), Argument.optional "first" filledInOptionals____.first (Encode.int), Argument.optional "before" filledInOptionals____.before (Encode.string), Argument.optional "last" filledInOptionals____.last (Encode.int) ]
                |> List.filterMap Basics.identity
    in
      Object.selectionForCompositeField "pilotConnection" optionalArgs____ (object____) (Basics.identity >> Decode.nullable)


type alias FilmConnectionOptionalArguments = { after : OptionalArgument String
 , first : OptionalArgument Int
 , before : OptionalArgument String
 , last : OptionalArgument Int }

filmConnection : (FilmConnectionOptionalArguments -> FilmConnectionOptionalArguments)
 -> SelectionSet decodesTo Api.Object.StarshipFilmsConnection
 -> SelectionSet (Maybe decodesTo) Api.Object.Starship
filmConnection fillInOptionals____ object____ =
    let
        filledInOptionals____ =
            fillInOptionals____ { after = Absent, first = Absent, before = Absent, last = Absent }

        optionalArgs____ =
            [ Argument.optional "after" filledInOptionals____.after (Encode.string), Argument.optional "first" filledInOptionals____.first (Encode.int), Argument.optional "before" filledInOptionals____.before (Encode.string), Argument.optional "last" filledInOptionals____.last (Encode.int) ]
                |> List.filterMap Basics.identity
    in
      Object.selectionForCompositeField "filmConnection" optionalArgs____ (object____) (Basics.identity >> Decode.nullable)


{-| The ISO 8601 date format of the time that this resource was created.
-}
created : SelectionSet (Maybe String) Api.Object.Starship
created =
      Object.selectionForField "(Maybe String)" "created" [] (Decode.string |> Decode.nullable)


{-| The ISO 8601 date format of the time that this resource was edited.
-}
edited : SelectionSet (Maybe String) Api.Object.Starship
edited =
      Object.selectionForField "(Maybe String)" "edited" [] (Decode.string |> Decode.nullable)


{-| The ID of an object
-}
id : SelectionSet Api.ScalarCodecs.Id Api.Object.Starship
id =
      Object.selectionForField "ScalarCodecs.Id" "id" [] (Api.ScalarCodecs.codecs |> Api.Scalar.unwrapCodecs |> .codecId |> .decoder)
