-- Do not manually edit this file, it was auto-generated by dillonkearns/elm-graphql
-- https://github.com/dillonkearns/elm-graphql
module Api.Object.Vehicle exposing (..)

import Graphql.Internal.Builder.Argument as Argument exposing (Argument)
import Graphql.Internal.Builder.Object as Object
import Graphql.SelectionSet exposing (SelectionSet)
import Graphql.OptionalArgument exposing (OptionalArgument(..))
import Graphql.Operation exposing (RootMutation, RootQuery, RootSubscription)
import Api.Object
import Api.Interface
import Api.Union
import Api.Scalar
import Api.InputObject
import Api.ScalarCodecs
import Json.Decode as Decode
import Graphql.Internal.Encode as Encode exposing (Value)

{-| The name of this vehicle. The common name, such as "Sand Crawler" or "Speeder
bike".
-}
name : SelectionSet (Maybe String) Api.Object.Vehicle
name =
      Object.selectionForField "(Maybe String)" "name" [] (Decode.string |> Decode.nullable)


{-| The model or official name of this vehicle. Such as "All-Terrain Attack
Transport".
-}
model : SelectionSet (Maybe String) Api.Object.Vehicle
model =
      Object.selectionForField "(Maybe String)" "model" [] (Decode.string |> Decode.nullable)


{-| The class of this vehicle, such as "Wheeled" or "Repulsorcraft".
-}
vehicleClass : SelectionSet (Maybe String) Api.Object.Vehicle
vehicleClass =
      Object.selectionForField "(Maybe String)" "vehicleClass" [] (Decode.string |> Decode.nullable)


{-| The manufacturers of this vehicle.
-}
manufacturers : SelectionSet (Maybe (List (Maybe String))) Api.Object.Vehicle
manufacturers =
      Object.selectionForField "(Maybe (List (Maybe String)))" "manufacturers" [] (Decode.string |> Decode.nullable |> Decode.list |> Decode.nullable)


{-| The cost of this vehicle new, in Galactic Credits.
-}
costInCredits : SelectionSet (Maybe Float) Api.Object.Vehicle
costInCredits =
      Object.selectionForField "(Maybe Float)" "costInCredits" [] (Decode.float |> Decode.nullable)


{-| The length of this vehicle in meters.
-}
length : SelectionSet (Maybe Float) Api.Object.Vehicle
length =
      Object.selectionForField "(Maybe Float)" "length" [] (Decode.float |> Decode.nullable)


{-| The number of personnel needed to run or pilot this vehicle.
-}
crew : SelectionSet (Maybe String) Api.Object.Vehicle
crew =
      Object.selectionForField "(Maybe String)" "crew" [] (Decode.string |> Decode.nullable)


{-| The number of non-essential people this vehicle can transport.
-}
passengers : SelectionSet (Maybe String) Api.Object.Vehicle
passengers =
      Object.selectionForField "(Maybe String)" "passengers" [] (Decode.string |> Decode.nullable)


{-| The maximum speed of this vehicle in atmosphere.
-}
maxAtmospheringSpeed : SelectionSet (Maybe Int) Api.Object.Vehicle
maxAtmospheringSpeed =
      Object.selectionForField "(Maybe Int)" "maxAtmospheringSpeed" [] (Decode.int |> Decode.nullable)


{-| The maximum number of kilograms that this vehicle can transport.
-}
cargoCapacity : SelectionSet (Maybe Float) Api.Object.Vehicle
cargoCapacity =
      Object.selectionForField "(Maybe Float)" "cargoCapacity" [] (Decode.float |> Decode.nullable)


{-| The maximum length of time that this vehicle can provide consumables for its
entire crew without having to resupply.
-}
consumables : SelectionSet (Maybe String) Api.Object.Vehicle
consumables =
      Object.selectionForField "(Maybe String)" "consumables" [] (Decode.string |> Decode.nullable)


type alias PilotConnectionOptionalArguments = { after : OptionalArgument String
 , first : OptionalArgument Int
 , before : OptionalArgument String
 , last : OptionalArgument Int }

pilotConnection : (PilotConnectionOptionalArguments -> PilotConnectionOptionalArguments)
 -> SelectionSet decodesTo Api.Object.VehiclePilotsConnection
 -> SelectionSet (Maybe decodesTo) Api.Object.Vehicle
pilotConnection fillInOptionals____ object____ =
    let
        filledInOptionals____ =
            fillInOptionals____ { after = Absent, first = Absent, before = Absent, last = Absent }

        optionalArgs____ =
            [ Argument.optional "after" filledInOptionals____.after (Encode.string), Argument.optional "first" filledInOptionals____.first (Encode.int), Argument.optional "before" filledInOptionals____.before (Encode.string), Argument.optional "last" filledInOptionals____.last (Encode.int) ]
                |> List.filterMap Basics.identity
    in
      Object.selectionForCompositeField "pilotConnection" optionalArgs____ (object____) (Basics.identity >> Decode.nullable)


type alias FilmConnectionOptionalArguments = { after : OptionalArgument String
 , first : OptionalArgument Int
 , before : OptionalArgument String
 , last : OptionalArgument Int }

filmConnection : (FilmConnectionOptionalArguments -> FilmConnectionOptionalArguments)
 -> SelectionSet decodesTo Api.Object.VehicleFilmsConnection
 -> SelectionSet (Maybe decodesTo) Api.Object.Vehicle
filmConnection fillInOptionals____ object____ =
    let
        filledInOptionals____ =
            fillInOptionals____ { after = Absent, first = Absent, before = Absent, last = Absent }

        optionalArgs____ =
            [ Argument.optional "after" filledInOptionals____.after (Encode.string), Argument.optional "first" filledInOptionals____.first (Encode.int), Argument.optional "before" filledInOptionals____.before (Encode.string), Argument.optional "last" filledInOptionals____.last (Encode.int) ]
                |> List.filterMap Basics.identity
    in
      Object.selectionForCompositeField "filmConnection" optionalArgs____ (object____) (Basics.identity >> Decode.nullable)


{-| The ISO 8601 date format of the time that this resource was created.
-}
created : SelectionSet (Maybe String) Api.Object.Vehicle
created =
      Object.selectionForField "(Maybe String)" "created" [] (Decode.string |> Decode.nullable)


{-| The ISO 8601 date format of the time that this resource was edited.
-}
edited : SelectionSet (Maybe String) Api.Object.Vehicle
edited =
      Object.selectionForField "(Maybe String)" "edited" [] (Decode.string |> Decode.nullable)


{-| The ID of an object
-}
id : SelectionSet Api.ScalarCodecs.Id Api.Object.Vehicle
id =
      Object.selectionForField "ScalarCodecs.Id" "id" [] (Api.ScalarCodecs.codecs |> Api.Scalar.unwrapCodecs |> .codecId |> .decoder)
